

'program GCA186
'railroad crossing controller for two directions on one track
Define CONF_WORD = 0x3f50

CMCON = 7
TRISA = 255
TRISB = 0
PORTB = 0
AllDigital

Symbol hall_a = RA6
Symbol hall_b = RA7
Symbol hall_c = RA0
Symbol hall_d = RA1
Symbol servo_1 = RB5
Symbol servo_2 = RB4
Dim servo_value As Word
Dim old_servo_1 As Bit
Dim old_servo_2 As Bit
Symbol flash_1 = RB3
Symbol flash_2 = RB2
Dim flashtime As Byte
Dim rel_off_delay As Byte
Symbol rel = RB1
Dim old_hall_a As Bit
Dim old_hall_b As Bit
Dim old_hall_c As Bit
Dim old_hall_d As Bit
Dim count_enter_a As Byte
Dim count_enter_d As Byte
Dim count_down_a_to_d As Byte
Dim count_down_d_to_a As Byte
Dim program As Byte
program = 0
old_hall_a = 0
old_hall_b = 0
old_hall_c = 0
old_hall_d = 0
old_servo_1 = 0
old_servo_2 = 0
count_down_a_to_d = 0
count_down_d_to_a = 0
count_enter_a = 0
count_enter_d = 0
'program option":
'program = 0  idle task
'_         1  entered a 'start activation of barriers and counting a
'_         2  BARRIERS ARE DOWN, wait loop before shutt off sound
'_         3  activated c 'start counting down
'_         4  counted to zero, start freeing barriers,
'_         5  waiting For count_down_a_to_d To be zero
'_         11  entered d 'start activation of barriers and counting a
'_         12  BARRIERS ARE DOWN, wait loop before shutt off sound
'_         13  activated b 'start counting down
'_         14  counted to zero, start freeing barriers, waiting for count_down_a_to_d to be zero
'_         15  waiting For count_down_d_to_a To be zero

servo_value = 800  'start in barrier up position
flash_1 = 1
flash_2 = 1
WaitMs 1000
main:
	If hall_a = 0 Then
		If old_hall_a = 0 Then
			old_hall_a = 1  'only one time reaction on hall_a
			Select Case program
			Case 0
				program = 1
				count_enter_a = count_enter_a + 1
				count_down_a_to_d = count_down_a_to_d + 1
			Case 1, 2, 3
				count_enter_a = count_enter_a + 1
				count_down_a_to_d = count_down_a_to_d + 1
			Case 11, 12, 13, 14, 15
				If count_down_d_to_a > 0 Then
					count_down_d_to_a = count_down_d_to_a - 1
				Endif
			Case Else
			EndSelect
		Endif
	Else
		old_hall_a = 0
	Endif
	If hall_d = 0 Then
		If old_hall_d = 0 Then
			old_hall_d = 1  'only one time reaction on hall_d
			Select Case program
			Case 0
				program = 11
				count_enter_d = count_enter_d + 1
				count_down_d_to_a = count_down_d_to_a + 1
			Case 11, 12, 13
				count_enter_d = count_enter_d + 1
				count_down_d_to_a = count_down_d_to_a + 1
			Case 1, 2, 3, 4, 5
				If count_down_a_to_d > 0 Then
					count_down_a_to_d = count_down_a_to_d - 1
				Endif
			Case Else
			EndSelect
		Endif
	Else
		old_hall_d = 0
	Endif
	If hall_c = 0 Then
		If old_hall_c = 0 Then
			old_hall_c = 1  'only one time reaction on hall_c
			Select Case program
			Case 1, 2, 3
				If program = 1 Then
					program = 2
				Endif
				If count_enter_a > 0 Then
					count_enter_a = count_enter_a - 1
				Else
					program = 4
				Endif
			Case Else
			EndSelect
		Endif
	Else
		old_hall_c = 0
	Endif
	If hall_b = 0 Then
		If old_hall_b = 0 Then
			old_hall_b = 1  'only one time reaction on hall_b
			Select Case program
			Case 11, 12, 13
				If program = 11 Then
					program = 12
				Endif
				If count_enter_d > 0 Then
					count_enter_d = count_enter_d - 1
				Else
					program = 14
				Endif
			Case Else
			EndSelect
		Endif
	Else
		old_hall_b = 0
	Endif
	Select Case program
	Case 1, 11  'starting barriers close
		rel = 0  'ACTIVATE SOUND
		rel_off_delay = 80
		If servo_value < 2196 Then
			servo_value = servo_value + 3
			servo_1 = 1
			WaitUs servo_value
			servo_1 = 0
			servo_2 = 1
			WaitUs servo_value
			servo_2 = 0
			WaitMs 15
		Else
			program = program + 1
			WaitMs 20
		Endif
	Case 2, 12  'waiting for sound to switch off
		If rel_off_delay > 0 Then
			rel_off_delay = rel_off_delay - 1
		Else
			rel = 1  'sound off
			program = program + 1
		Endif
		WaitMs 20
	Case 4, 14
		If servo_value > 804 Then
			servo_value = servo_value - 3
			servo_1 = 1
			WaitUs servo_value
			servo_1 = 0
			servo_2 = 1
			WaitUs servo_value
			servo_2 = 0
			WaitMs 15
		Else
			WaitMs 20
			program = program + 1
		Endif
	Case 5
		If count_down_a_to_d = 0 Then
			program = 0
		Endif
		WaitMs 20
	Case 15
		If count_down_d_to_a = 0 Then
			program = 0
		Endif
		WaitMs 20
	Case Else
		WaitMs 20
	EndSelect
	Select Case program
	Case 0, 5, 15
		flash_1 = 0
		flash_2 = 0
	Case Else
		If flashtime < 24 Then
			flashtime = flashtime + 1
		Else
			flashtime = 0
			flash_1 = flash_2
			flash_2 = Not flash_2
		Endif
	EndSelect
Goto main
End                                               
